<?php
require_once("inc/guard.inc.php");
require_once("inc/mysql.inc.php");
require_once("inc/system.inc.php"); // For do_as_boincuser()
require_once("inc/dict_functions.inc.php"); // Helping functions for password dictionary management

if (!isset($_POST['dict_files']) || empty($_POST['dict_files'])) {
    echo "<p>No dictionaries selected.</p>";
    goto end;
}

if (!isset($_POST['operation']) || empty($_POST['operation'])) {
    echo "<p>No operation selected.</p>";
    goto end;
}

if ($_POST['operation'] == 'examine') {
    foreach ($_POST['dict_files'] as $dict) {
        $filename = html_entity_decode($dict);
        $fullpath = $config['dict_dir'] . "/" . $filename;
        $pw_count = intval(explode(' ', do_as_boincuser("wc -l $fullpath"))[0]);
        $pw_display = 5;
        
        echo "<h2>Dictionary " . htmlentities($dict) .  "</h2>";
        echo "<table><tr><td style=\"width: 250px;\">\n";
        
        echo "Size: " . formatSizeUnits(filesize($fullpath)) . "<br/>\n";
        echo "Passwords: $pw_count<br/>\n";
        echo "<a href=\"dictfile.php?f=$dict\" target=\"_blank\">Download dictionary</a>";
        
        echo "</td><td>\n";
        echo "<span style=\"font-family: Courier; size: 10px;\">";
        echo nl2br(do_as_boincuser("head -n $pw_display $fullpath"));
        if ($pw_count > $pw_display) {
            echo "...";
        }
        echo "</span>";
        echo "</td></tr></table>\n";
        echo "<hr/>";
    }
    
} else if ($_POST['operation'] == 'delete') {
    foreach ($_POST['dict_files'] as $dict) {
        $filename = html_entity_decode($dict);
        $fullpath = $config['dict_dir'] . "/" . $filename;
        do_as_boincuser("rm " . $fullpath);
        echo "Dictionary " . htmlentities($filename) . " deleted.<br/>";
    }
}



end:
?>
<p><a href="?i=dictionaries">Return to dictionaries</a></p>
