<?php
require_once("inc/guard.inc.php");
require_once("inc/mysql.inc.php");

// Helping functions for mapping modification

// Returns true if a given host is mapped to a given package
function mapping_exists($boinc_host_id, $pkg_id) {
    global $config;
    global $mysqli;
    $sql = "SELECT COUNT(id) FROM `" . $config['mysql_prefix'] . "host_activity` WHERE boinc_host_id = $boinc_host_id AND package_id = $pkg_id";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to access database to look for mappings!</p><br/>\n");
    }

    $row = $result->fetch_row();
    if ($row[0] > 0) {
        return true;
    } else {
        return false;
    }
}

// Adds a mapping for a given host and a given package (making the host active)
function add_mapping($boinc_host_id, $pkg_id) {
    global $config;
    global $mysqli;
    $sql = "INSERT INTO `" . $config['mysql_prefix'] . "host_activity`(boinc_host_id, package_id) VALUES($boinc_host_id, $pkg_id)";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to add mapping!</p><br/>\n");
    }
}

/*
// Get IDs of all mapped hosts for a given pacakge
function get_all_mapped($pkg_id) {
    global $config;
    global $mysqli;
    $sql = "SELECT boinc_host_id FROM `" . $config['mysql_prefix'] . "host-activity` WHERE packageId = $pkg_id AND active = 1";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to access database to look for mappings!</p><br/>\n");
    }
    $mapped = array();
    while ($host = $result->fetch_array(MYSQLI_ASSOC)) {
        array_push($mapped, $host['boinc_host_id']);
    }
    return $mapped;
}
*/

// Removes mapping of all hosts for a given package, excluding the $excluded_ids
function cleanup_package($excluded_ids, $pkg_id) {
    global $config;
    global $mysqli;
    
    $sql_excl_list = "(";
    $numof_excluded = sizeof($excluded_ids);
    if ($numof_excluded > 0) {
        $sql_excl_list .= $excluded_ids[0];
        for ($i = 1; $i < $numof_excluded; $i++) {
            $sql_excl_list .= ", " . $excluded_ids[$i];
        }
    }
    $sql_excl_list .= ")";
    
    $sql = "DELETE FROM `" . $config['mysql_prefix'] . "host_activity` WHERE package_id = $pkg_id";
    if ($numof_excluded > 0) {
        $sql .= " AND (boinc_host_id NOT IN $sql_excl_list)";
    }
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to access database to deleted unnecessary mappings!</p><br/>\n");
    }
}

//////////////////////////////////////////////

$a = array(1, 2, 3);

$package_exists = 0;
$pkg_id = -1;
$name = "(unknown)";
if (isset($_GET['pkg_id']) && ctype_digit($_GET['pkg_id'])) {
    $pkg_id = intval($_GET['pkg_id']);
    
    // Lets look if the selected package exists
    $sql = "SELECT COUNT(id), name FROM `" . $config['mysql_prefix'] . "package` WHERE id = $pkg_id";
    
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to access database to look for packages!</p><br/>\n");
    }
    $row = $result->fetch_row();
    if ($row[0] > 0) {
        $package_exists = 1;
    }
    $name = htmlentities(stripslashes($row[1]));
}

if (!$package_exists) {
    goto pkg_not_found;
}

if (isset($_POST['update'])) {
    if (isset($_POST['mapped_hosts'])) {
        $mapped_ids = $_POST['mapped_hosts'];
    } else {
        $mapped_ids = array();
    }
    foreach ($mapped_ids as $boinc_host_id) {
        if (!intval($boinc_host_id)) {
            die('Possible attack detected!');
        }
        //echo "<p>Selected $boinc_host_id</p>";
        if (!mapping_exists($boinc_host_id, $pkg_id)) {
            add_mapping($boinc_host_id, $pkg_id);
        }
    }
    cleanup_package($mapped_ids, $pkg_id);
    echo "<p>Host mapping updated.</p>";
}


echo "<h1>Host mapping for package with ID $pkg_id ($name)</h1>\n";
/*
echo "Click <a href=\"?i=hosts&display=active\">here</a> to set the activity of hosts.\n";
echo "<hr/>\n";
*/

// Get available hosts
$available = array();

$sql = "SELECT id, userid, domain_name, last_ip_addr, p_model, os_name, os_version FROM ";
$sql .= "host WHERE id";
$sql .=" NOT IN (SELECT boinc_host_id FROM `" . $config['mysql_prefix'] . "host_activity` WHERE package_id = $pkg_id) ORDER BY id DESC";

if (!$result = $mysqli->query($sql)) {
    echo mysqli_error($mysqli);
    die("<p>Unable to read host information!</p><br/>\n");
}

if ($result->num_rows > 0) {
    while ($host = $result->fetch_array(MYSQLI_ASSOC)) {
        $sql2 = "SELECT name FROM `user` WHERE id = " . $host['userid'];
        if (!$result2 = $mysqli->query($sql2)) {
            continue;
        }
        $user = array();
        if ($result2->num_rows > 0) {
            $user = $result2->fetch_row();
            $available[$host['id']] = $host['id'] . " - " . htmlentities(stripcslashes($host['domain_name'])) . " (" . htmlentities(stripcslashes($user[0])) .
            ", " . $host['last_ip_addr'] . ")";
        }
    }
}


// Get mapped hosts
$mapped = array();

$sql = "SELECT id, userid, domain_name, last_ip_addr, p_model, os_name, os_version FROM ";
$sql .= "host WHERE id";
$sql .=" IN (SELECT boinc_host_id FROM `" . $config['mysql_prefix'] . "host_activity` WHERE package_id = $pkg_id) ORDER BY id DESC";

if (!$result = $mysqli->query($sql)) {
    echo mysqli_error($mysqli);
    die("<p>Unable to read host information!</p><br/>\n");
}

if ($result->num_rows > 0) {
    while ($host = $result->fetch_array(MYSQLI_ASSOC)) {
        $sql2 = "SELECT name FROM `user` WHERE id = " . $host['userid'];
        if (!$result2 = $mysqli->query($sql2)) {
            continue;
        }
        $user = array();
        if ($result2->num_rows > 0) {
            $user = $result2->fetch_row();
            $mapped[$host['id']] = $host['id'] . " - " . htmlentities(stripcslashes($host['domain_name'])) . " (" . htmlentities(stripcslashes($user[0])) .
            ", " . $host['last_ip_addr'] . ")";
        }
    }
}
?>
<style type="text/css">
.container {
    overflow-y: scroll;
}
    
SELECT, INPUT[type="text"] {
    width: 480px;
    box-sizing: border-box;
}
SECTION {
    padding: 8px;
    #background-color: #f0f0f0;
    overflow: auto;
}
SECTION > DIV {
    float: left;
    padding: 4px;
}
SECTION > DIV + DIV {
    width: 40px;
    text-align: center;
}
</style>
<form id="#formHosts" name="form_hosts" action="index.php?i=host_mapping&pkg_id=<?=$pkg_id ?>" method="POST" enctype="multipart/form-data">
<input type="hidden" name="update" value="yes" />
<section class="container">
    <div>
        Available hosts:<br/>
        <select id="leftValues" size="20" multiple>
<?php
foreach ($available as $boinc_host_id => $host_name) {
    echo "<option value=\"$boinc_host_id\">$host_name</option>\n";
}
?>
        </select>
    </div>
    <div>
        <input type="button" id="btnRight" value="&gt;&gt;" />
        <input type="button" id="btnLeft" value="&lt;&lt;" />
    </div>
    <div>
        Mapped:<br/>
        <select id="rightValues" class="selectionList" name="mapped_hosts[]" size="20" multiple>
<?php
foreach ($mapped as $boinc_host_id => $host_name) {
    echo "<option value=\"$boinc_host_id\">$host_name</option>\n";
}
?>
        </select>
    </div>
</section>
<input id="btnSubmit" type="button" value="Save mapping"></input>
<!-- not a submit type because we need to use functions below to select all from list before submitting -->
</form>
<form action="index.php?i=host_mapping&pkg_id=<?=$pkg_id ?>" method="POST" enctype="text/plain">
<input type="submit" value="Reset changes"></input>
</form>

<script type="text/javascript">
function selectAllMapped() {
    var aSelect = document.form_hosts["mapped_hosts[]"]; 
    var aSelectLen = aSelect.length;
    for(i = 0; i < aSelectLen; i++) {
        aSelect.options[i].selected = true;
    }
}
</script>

<script type="text/javascript">
$("#btnLeft").click(function () {
    var selectedItem = $("#rightValues option:selected");
    $("#leftValues").append(selectedItem);
});

$("#btnRight").click(function () {
    var selectedItem = $("#leftValues option:selected");
    $("#rightValues").append(selectedItem);
});

// Send all, not just selected
$("#btnSubmit").click(function () {
    selectAllMapped();
    document.form_hosts.submit();
});
</script>


<?php
goto ok;

pkg_not_found:
echo "<p>Selected package was not found</p>\n";
echo "<p>(Or no package selected)</p>\n";

ok:
?>
