<?php
require_once("inc/guard.inc.php");

// Package builder settings
$path = './inc/package_builder';                    // Directory with Package builder submodules
$toinclude = array('defaults', 'process', 'form');  // List of files included from each module
$excluded_types = array('common', 'test');          // List of attack types to be excluded from the list

// Take only directories which should be included, filter others
function dir_filter($name) {
    global $path;
    global $excluded_types;
    // Check if file is truly a directory
    if (is_dir($path . '/' . $name) && $name != '.' && $name != '..') {
        // check wheter directory is excluded or not
        if (array_search($name, $excluded_types) !== FALSE) { // !== is necessary here!
            return false;
        }
        return true;
    } else {
        return false;
    }
}

// Get all possible attack types
$attack_types = array_filter(scandir($path), 'dir_filter');

// Include common
require_once($path . '/common/defaults_common.inc.php');
require_once($path . '/common/process_common.inc.php');
require_once($path . '/common/form_common.inc.php');

// Include submodules
foreach ($attack_types as &$attack) {
    foreach ($toinclude as &$file) {
        $full_path = $path . '/' . $attack . '/' . $file . '_' . $attack . '.inc.php';
        require_once($full_path); // Include file
    }
}

?>
