<?php
require_once("inc/guard.inc.php");

// Set default values
$input_method = "file";

function set_defaults(&$pkg, &$to_dictionary) {
    $pkg['info_only'] = false; // true = Do NOT add anything to database - display info only
    $pkg['hash_in_cache'] = false;
    
    // Define all common options
    $pkg['attack_modes'] = array(); // attack(name) => -a parameter
    
    $pkg['start_now'] = 1;
    $pkg['start_day'] = intval(date('j'));
    $pkg['start_month'] = intval(date('n'));
    $pkg['start_year'] = intval(date('Y'));
    $pkg['start_hour'] = 0;
    $pkg['start_minute'] = 0;
    $pkg['start_second'] = 0;
    
    $pkg['end_never'] = 1;
    $pkg['end_day'] = 0;
    $pkg['end_month'] = 0;
    $pkg['end_year'] = intval(date('Y')) + 1;
    $pkg['end_hour'] = 0;
    $pkg['end_minute'] = 0;
    $pkg['end_second'] = 0;
    
    $pkg['token'] = "none";
    $pkg['attack'] = "brute";
    $pkg['attack_mode'] = -1;
    $pkg['hash_type'] = -1;
    $pkg['hash'] = "";
    $pkg['status'] = 0;
    $pkg['result'] = "";
    $pkg['keyspace'] = 0;
    $pkg['hc_keyspace'] = 0;
    $pkg['indexes_verified'] = 0;
    $pkg['current_index'] = 0;
    $pkg['time'] = "NOW()";
    $pkg['name'] = "";
    $pkg['comment'] = "";
    $pkg['time_start'] = "NOW()";
    $pkg['time_end'] = "NULL";
    $pkg['cracking_time'] = 0;
    $pkg['seconds_per_job'] = settings_get('default_seconds_per_job');
    $pkg['config'] = "";    
    $pkg['dict1'] = "";
    $pkg['dict2'] = "";
    $pkg['replicate_factor'] = 1;
    
    // Non-db options
    $pkg['input_method'] = 'file';
    $pkg['cracker_override'] = 0;
    $pkg['enable_opencl'] = 1;
    $pkg['xml_data'] = "";
    $pkg['verify_hash_format'] = settings_get('default_verify_hash_format');
    $pkg['check_hashcache'] = settings_get('default_check_hashcache');
    $pkg['hash_entered'] = false;
    
    // Which comes to config TLV dictionary 
    $to_dictionary['attack'] = 'String';
    $to_dictionary['attack_mode'] = 'UInt';
    $to_dictionary['name'] = 'String';
    $to_dictionary['hash_type'] = 'UInt';
    $to_dictionary['enable_opencl'] = 'Bool';
}
?>
