<?php

function draw_form(&$pkg) {
    global $attack_types;
    global $attack_caption;
    global $months;
    
    echo "<form id=\"package_form\" action=\"index.php?i=new_package\" method=\"POST\" enctype=\"multipart/form-data\">\n";
    echo "<input type=\"hidden\" name=\"add\" value=\"yes\" />\n";
    echo "<table id=\"input_form\">\n";
    
    // GENERAL SETTINGS ==================================================================
    echo "<tr>\n";
    echo "<td class=\"bg_a\">\n";
    echo "<h2>General settings</h2>\n";
    echo "<table class=\"inner_form\">\n";
    
    // Name
    echo "<tr>\n";
    echo "<td align=\"right\">Name:</td>\n";
    echo "<td>\n";
    echo "<input type=\"text\" name=\"name\" value=\"" . htmlentities($pkg['name']) . "\" placeholder=\"Enter package name\" size=\"20\"/>";
    echo "</td>\n";
    echo "</tr>\n";
    
    // Comment
    echo "<tr>\n";
    echo "<td align=\"right\">Comment:</td>\n";
    echo "<td>\n";
    echo "<input type=\"text\" name=\"comment\" value=\"" . htmlentities($pkg['comment']) . "\" placeholder=\"Enter optional comment\" size=\"58\"/>\n";
    echo "</td>\n";
    echo "</tr>\n";
    
    echo "</table>\n";
    echo "</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "<td class=\"bg_a\">\n";
    // INPUT SETTINGS ==================================================================
    echo "<h2>Input settings</h2>\n";
    echo "<table class=\"inner_form\">\n";
    
    // Hash type
    echo "<tr>\n";
    echo "<td align=\"right\">Hash type:</td>\n";
    echo "<td>\n";
    echo "<select name=\"hash_type\">\n";
    echo "    <option value=\"-1\">Autodetect</option>\n";
    
    /*
    $formats = get_hashtypes();
    foreach ($formats as $format) {
        $display_name = $format['id'] . " | " . $format['name'] . " (" . $format['category'] . ")";
        $hash_type_selected = "";
        if (isset($_POST['hash_type']) && is_numeric($_POST['hash_type'])) {
            if (intval($_POST['hash_type']) == $format['id']) {
                $hash_type_selected = " selected";
            }
        }
        echo "    <option value=\"" . $format['id'] . "\"$hash_type_selected>$display_name</option>\n";
    }
    */
    $categories = get_hashtypes_by_categories();
    foreach ($categories as $cat => $formats) {
        echo "    <option value=\"-1\">============ $cat ============</option>\n";
        foreach ($formats as $format) {
            $display_name = $format['id'] . " | " . $format['name'];
            $hash_type_selected = "";
            if (isset($_POST['hash_type']) && is_numeric($_POST['hash_type'])) {
                if (intval($_POST['hash_type']) == $format['id']) {
                    $hash_type_selected = " selected";
                }
            }
            echo "    <option value=\"" . $format['id'] . "\"$hash_type_selected>$display_name</option>\n";
        }
        echo "    <option value=\"-1\"> </option>\n";
    }
    
    echo "</select>\n";
    echo "</td>\n";
    echo "</tr>\n";
    
    // Input method
    echo "<tr>\n";
    echo "<td align=\"right\">Input method:</td>\n";
    echo "<td>\n";
    $cracker_im_file_checked = "";
    $cracker_hash_file_checked = "";
    $cracker_hash_text_checked = "";
    
    $inp_file_selector_display = "none";
    $inp_hash_inputbox_display = "none";
    
    if ($pkg['input_method'] == 'file') {
        $cracker_im_file_checked = " checked";
        $inp_file_selector_display = "table-row";
    } else if ($pkg['input_method'] == 'hash') {
        $cracker_hash_file_checked = " checked";
        $inp_file_selector_display = "table-row";
    } else {
        $cracker_hash_text_checked = " checked";
        $inp_hash_inputbox_display = "table-row";
    }
    echo "<input type=\"radio\" name=\"input_method\" onclick=\"javascript:set_input_method('file')\" value=\"file\"$cracker_im_file_checked> Encrypted file<br/>\n";
    echo "<input type=\"radio\" name=\"input_method\" onclick=\"javascript:set_input_method('file')\" value=\"hash_file\"$cracker_hash_file_checked> Hash in file\n";
    echo "<span class=\"comment\">(Hash type must be selected manually)</span><br/>\n";
    echo "<input type=\"radio\" name=\"input_method\" onclick=\"javascript:set_input_method('hash')\" value=\"hash_text\"$cracker_hash_text_checked> Hash as text\n";
    echo "<span class=\"comment\">(Hash type must be selected manually)</span><br/>\n";
    echo "</td>\n";
    echo "</tr>\n";
    
    // Input file
    echo "<tr id=\"input_fselector\" style=\"display:$inp_file_selector_display\">\n";
    echo "<td align=\"right\">Input file:</td>\n";
    echo "<td>\n";
    echo "<input type=\"file\" name=\"input_file\" />\n";
    echo "</td>\n";
    echo "</tr>\n";    
    
    // Textbox for hash
    echo "<tr id=\"input_hashbox\" style=\"display:$inp_hash_inputbox_display\">";
    echo "<td align=\"right\">Hash:</td>\n";
    echo "<td>\n";
    $hash_text = "";
    if (isset($_POST['hash_text']) && !empty($_POST['hash_text'])) {
        $hash_text = htmlentities($_POST['hash_text']);
    }
    echo "<input type=\"text\" name=\"hash_text\" value=\"$hash_text\"/>\n";
    echo "</td>\n";
    echo "</tr>\n";    
    
    
    // Verify hash format
    $verify_hash_format_checked = "";
    if (isset($pkg['verify_hash_format']) && $pkg['verify_hash_format'] == 1) {
        $verify_hash_format_checked = " checked";
    }
    echo "<tr>\n";
    echo "<td align=\"right\">Additional options:</td>\n";
    echo "<td>\n";
    echo "<input type=\"checkbox\" value=\"yes\" name=\"verify_hash_format\"$verify_hash_format_checked/> Verify hash format before adding\n";
    echo "<span class=\"comment\">(May take a while)</span><br/>\n";
    echo "</td>\n";
    echo "</tr>\n";    
    
    echo "</table>\n";
    echo "</td>\n";
    echo "</tr>\n";
    
    // ATTACK SETTINGS ==================================================================
    echo "<tr>\n";
    echo "<td class=\"bg_a\">\n";
    echo "<h2>Attack settings</h2>\n";
    
    echo "<table class=\"inner_form\" style=\"width:100%\">\n";
    echo "<tr>\n";
    
    // Attack type
    echo "<td style=\"vertical-align:top\">\n";
    echo "Attack type:<br/>";
    // Include submodules
    $attack_type_checked = array();
    $attack_display_style = array();
    
    foreach ($attack_types as &$attack) {
        $attack_type_checked[$attack] = "";
        $attack_display_style[$attack] = "none";
    }
    
    
    if (isset($pkg['attack'])) {
        $attack_type_checked[$pkg['attack']] = " checked";
        $attack_display_style[$pkg['attack']] = "inline-block";
    }
    
    foreach ($attack_types as &$attack) {
        $caption = $attack;
        if (isset($attack_caption[$attack])) {
            $caption = $attack_caption[$attack];
        }
        echo "<input onclick=\"set_attack('$attack')\" type=\"radio\" name=\"attack\" value=\"$attack\"" . $attack_type_checked[$attack] . "> $caption<br/>\n";
    }
    
    echo "</td>\n";

    // ======================= Attack type (password generator) form(s) =======================
    //echo "<td style=\"vertical-align: top; background-color: #b3ffff; border: 1px solid black;\" >\n";
    echo "<td style=\"vertical-align: top;\">\n";
    // Draw (hidden) forms for attack types;
    foreach ($attack_types as &$attack) {
        echo "<div id=\"form_$attack\" style=\"display:" . $attack_display_style[$attack] . "\">\n";
        echo "<div align=\"center\"><b>" . $attack_caption[$attack] . " settings</b></div>";
        echo "<hr width=\"100%\" align=\"left\" />\n";
        
        $func = 'draw_form_' . $attack;
        $func($pkg);
        
        echo "</div>\n";
    }
    echo "</td>\n";
    // ==========================================================================================
    echo "</tr>\n";
    echo "</table>\n";
    echo "</td>\n";
    echo "</tr>\n";

    // MISC SETTINGS ==================================================================
    echo "<tr>\n";
    echo "<td class=\"bg_a\">\n";
    echo "<h2>Miscellanious settings</h2>\n";
    
    echo "<table class=\"date_selector\">";
    
    // START
    echo "<tr><td>Start computing on: </td><td id=\"start_selector\">";
    $disabled = "";
    if ($pkg['start_now']) {
        $disabled = " disabled=\"disabled\"";
    }
    
    echo "<select name=\"start_day\"$disabled>\n";
    for ($d = 1; $d <= 31; $d++) {
        $selected = "";
        if ($d == $pkg['start_day']) {
            $selected = " selected";
        }
        echo "<option value=\"$d\"$selected>$d</option>\n";
    }
    echo "</select>\n";
    echo "&nbsp;";
    echo "<select name=\"start_month\"$disabled>\n";
    for ($m = 1; $m <= 12; $m++) {
        $selected = "";
        if ($m == $pkg['start_month']) {
            $selected = " selected";
        }
        echo "<option value=\"$m\"$selected>" . $months[$m - 1] . "</option>\n";
    }
    echo "</select>\n";
    echo "&nbsp;";
    echo "<select name=\"start_year\"$disabled>\n";
    for ($y = intval(date('Y')); $y <= intval(date('Y')) + 10; $y++) {
        $selected = "";
        if ($y == $pkg['start_year']) {
            $selected = " selected";
        }
        echo "<option value=\"$y\"$selected>" . $y . "</option>\n";
    }
    echo "</select>\n";
    echo " at ";
    echo "<input type=\"text\"$disabled name=\"start_hour\" value=\"" . timeval_twopos($pkg['start_hour']) . "\" style=\"width:32px;\" /> : ";
    echo "<input type=\"text\"$disabled name=\"start_minute\" value=\"" . timeval_twopos($pkg['start_minute']) . "\" style=\"width:32px;\" /> : ";
    echo "<input type=\"text\"$disabled name=\"start_second\" value=\"" . timeval_twopos($pkg['start_second']) . "\" style=\"width:32px;\" />";
    
    $start_now_checked = "";
    if ($pkg['start_now']) {
        $start_now_checked = " checked";
    }
    echo "</td><td>";
    echo "&nbsp;<input type=\"checkbox\" value=\"yes\" onchange=\"handle_start_now(this);\" name=\"start_now\"$start_now_checked/> now\n";
    
    // END
    echo "</td></tr><tr><td>Stop computing on:</td><td id=\"end_selector\">";
    $disabled = "";
    if ($pkg['end_never']) {
        $disabled = "disabled=\"disabled\"";
    }
    
    echo "<select name=\"end_day\"$disabled>\n";
    for ($d = 1; $d <= 31; $d++) {
        $selected = "";
        if ($d == $pkg['end_day']) {
            $selected = " selected";
        }
        echo "<option value=\"$d\"$selected>$d</option>\n";
    }
    echo "</select>\n";
    echo "&nbsp;";
    echo "<select name=\"end_month\"$disabled>\n";
    for ($m = 1; $m <= 12; $m++) {
        $selected = "";
        if ($m == $pkg['end_month']) {
            $selected = " selected";
        }
        echo "<option value=\"$m\"$selected>" . $months[$m - 1] . "</option>\n";
    }
    echo "</select>\n";
    echo "&nbsp;";
    echo "<select name=\"end_year\"$disabled>\n";
    for ($y = intval(date('Y')); $y <= intval(date('Y')) + 10; $y++) {
        $selected = "";
        if ($y == $pkg['end_year']) {
            $selected = " selected";
        }
        echo "<option value=\"$y\"$selected>" . $y . "</option>\n";
    }
    echo "</select>\n";
    echo " at ";
    echo "<input type=\"text\"$disabled name=\"end_hour\" value=\"" . timeval_twopos($pkg['start_hour']) . "\" style=\"width:32px;\" /> : ";
    echo "<input type=\"text\"$disabled name=\"end_minute\" value=\"" . timeval_twopos($pkg['start_minute']) . "\" style=\"width:32px;\" /> : ";
    echo "<input type=\"text\"$disabled name=\"end_second\" value=\"" . timeval_twopos($pkg['start_second']) . "\" style=\"width:32px;\" />";
    
    $end_never_checked = "";
    if ($pkg['end_never']) {
        $end_never_checked = " checked";
    }
    
    echo "</td><td>";
    echo "&nbsp;<input type=\"checkbox\" value=\"yes\" onchange=\"handle_end_never(this);\" name=\"end_never\"$end_never_checked/> never\n";
    
    echo "</td></tr></table>";
    
    // OpenCL Support
    //echo "GPU acceleration:<br/>";
    // Check the package if OpenCL/CUDA are enabled
    $opencl_checked = "";
    if ($pkg['enable_opencl']) {
        $opencl_checked = " checked";
    }
    
    
    // Desired time (in seconds) for each job
    echo "Desired time for each job: \n";
    echo "<input type=\"text\" name=\"seconds_per_job\" value=\"" . htmlentities($pkg['seconds_per_job']) . "\" size=\"5\" /> seconds<br/>\n";
    
    echo "<input type=\"checkbox\" name=\"enable_opencl\" value=\"yes\"$opencl_checked> Enable OpenCL\n";
    echo "<span class=\"comment\">(Actual use depends on client's support)</span><br/>";
    
    // Check hashcache?
    $check_hashcache_checked = "";
    if (isset($pkg['check_hashcache']) && $pkg['check_hashcache'] == 1) {
        $check_hashcache_checked = " checked";
    }
    echo "<input type=\"checkbox\" value=\"yes\" name=\"check_hashcache\"$check_hashcache_checked/> Check hash cache first<br/>\n";
    
    // Display info only
    $check_info_only = "";
    if (isset($pkg['info_only']) && $pkg['info_only']) {
        $check_info_only = " checked";
    }
    echo "<input type=\"checkbox\" value=\"yes\" name=\"info_only\"$check_info_only/> Do not create, compute keyspace only<br/>\n";

    
    echo "</td>\n";
    echo "<tr>\n";
    echo "<td colspan=\"2\" align=\"center\">\n";
    echo "<button type=\"submit\"> Add package </button>\n";
    echo "</td>\n";
    echo "</tr>\n";


    echo "</table>\n";


    echo "</form><br/>\n";


    // Attack type client-side selector script
    echo "<script type=\"text/javascript\">\n";
    echo "function set_attack(type) {\n";
    foreach ($attack_types as &$attack) {
        echo "    document.getElementById(\"form_$attack\").style.display='none';\n";
    }
    foreach ($attack_types as &$attack) {
        echo "    if (type == '$attack') {\n";
        echo "        document.getElementById(\"form_$attack\").style.display='inline-block';\n";
        echo "    }\n";
    }
    echo "}\n";
    echo "</script>\n";
    
    // Input method selector script
    echo "<script type=\"text/javascript\">\n";
    echo "function set_input_method(type) {\n";
        echo "    if (type == 'file') {\n";
        echo "        document.getElementById(\"input_fselector\").style.display='table-row';\n";
        echo "        document.getElementById(\"input_hashbox\").style.display='none';\n";
        echo "    } else if (type == 'hash') {\n";
        echo "        document.getElementById(\"input_fselector\").style.display='none';\n";
        echo "        document.getElementById(\"input_hashbox\").style.display='table-row';\n";
        echo "    }\n";
    echo "}\n";
    echo "</script>\n";
}
?>
<script type="text/javascript">

function handle_start_now(cb) {  
    if (cb.checked) {
        $("#start_selector").find("input,button,textarea,select").attr("disabled", "disabled");
    } else {
        $("#start_selector").find("input,button,textarea,select").attr("disabled", "");
    }
}

function handle_end_never(cb) {  
    if (cb.checked) {
        $("#end_selector").find("input,button,textarea,select").attr("disabled", "disabled");
    } else {
        $("#end_selector").find("input,button,textarea,select").attr("disabled", "");
    }
}
</script>
