<?php
require_once("inc/guard.inc.php");

ini_set('display_errors', 1); // TODO: remove
ini_set('display_startup_errors', 1); // TODO: remove
error_reporting(E_ALL); // TODO: remove

function add_error($err) {
    global $error, $ok;
    $error .= "<p><font color=\"red\">$err</font></p>\n";
    $ok = FALSE;
}

function print_pkg_info($pkg) {
    foreach ($pkg as $key => $val) {
        echo "$key: " . htmlentities($val). "<br/>\n";
    }
}

function error_cleanup($token) {
    global $config;
    global $mysqli;
    $sql = "DELETE FROM `" . $config['mysql_prefix'] . "package` WHERE token = $token";
    $mysqli->query($sql);
}

// Check entered values ==============================================================

function process_package(&$pkg, &$ok) {
    global $attack_types;
    global $config;
    global $mysqli;
    global $to_dictionary;
    //global $pkg;
    //global $_POST;
    
    // Package name
    if (isset($_POST['name']) && !empty($_POST['name'])) {
        $pkg['name'] = $_POST['name'];
    } else {
        add_error("You have to enter the package name!");
    }

    // Package comment
    if (isset($_POST['comment']) && !empty($_POST['comment'])) {
        $pkg['comment'] = $_POST['comment'];
    }

    // Input method
    if (isset($_POST['input_method'])) {
        if ($_POST['input_method'] == 'file' || $_POST['input_method'] == 'hash_file' || $_POST['input_method'] == 'hash_text') {
            $pkg['input_method'] = $_POST['input_method'];
        } else {
            add_error("Incorrect input method!");
        }
    } else {
        add_error("You have to set the data input method!");
    }
    
    // Hash type
    if (isset($_POST['hash_type'])) {
        if (!is_numeric($_POST['hash_type'])) {
            add_error("Hash type must be a number!");
        } elseif ($_POST['hash_type'] != "-1" && !hash_type_exists($_POST['hash_type'])) {
            add_error("Selected hash type is not supported!");
        } else {
            $pkg['hash_type'] = intval($_POST['hash_type']);
        }
    } else {
        add_error("You have to set the hash type!");
    }
    
    // Verify hash format?
    if (isset($_POST['verify_hash_format']) && $_POST['verify_hash_format'] == 'yes') {
        $pkg['verify_hash_format'] = 1;
    } else {
        $pkg['verify_hash_format'] = 0;
    }

    // Attack type
    if (isset($_POST['attack'])) {
        if (array_search($_POST['attack'], $attack_types) !== FALSE) {
            $pkg['attack'] = $_POST['attack'];
        }
    } else {
        add_error("You have to choose the attack type!");
    }    

    // Check if OpenCL is enabled
    if (isset($_POST['enable_opencl']) && $_POST['enable_opencl'] == 'yes') {
        $pkg['enable_opencl'] = 1;
    } else {
        $pkg['enable_opencl'] = 0;
    }
    
    // Check hashcache?
    if (isset($_POST['check_hashcache']) && $_POST['check_hashcache'] == 'yes') {
        $pkg['check_hashcache'] = 1;
    } else {
        $pkg['check_hashcache'] = 0;
    }
    
    // Display info only?
    if (isset($_POST['info_only']) && $_POST['info_only'] == 'yes') {
        $pkg['info_only'] = true;
    } else {
        $pkg['info_only'] = false;
    }

    // Desired job time
    $pkg['seconds_per_job'] = $_POST['seconds_per_job'];
    if (isset($_POST['seconds_per_job']) && !empty($_POST['seconds_per_job'])) {
        if (!ctype_digit($_POST['seconds_per_job']) || intval($_POST['seconds_per_job']) <= 0) {
            add_error("The desired job time has to be a positive integer!");
        } else {
            $pkg['seconds_per_job'] = intval($_POST['seconds_per_job']);
        }
    } else {
        add_error("You have to enter the desired job time!");
    }
    
    // Check start time
    if (isset($_POST['start_now']) && $_POST['start_now'] == 'yes') {
        $pkg['start_now'] = 1;
        $pkg['start_day'] = intval(date('j'));
        $pkg['start_month'] = intval(date('n'));
        $pkg['start_year'] = intval(date('Y'));
        $pkg['start_hour'] = 0;
        $pkg['start_minute'] = 0;
        $pkg['start_second'] = 0;
        $pkg['time_start'] = "NOW()";
    } else {
        $pkg['start_now'] = 0;
        $pkg['start_day'] = $_POST['start_day'];
        $pkg['start_month'] = $_POST['start_month'];
        $pkg['start_year'] = $_POST['start_year'];
        $pkg['start_hour'] = $_POST['start_hour'];
        $pkg['start_minute'] = $_POST['start_minute'];
        $pkg['start_second'] = $_POST['start_second'];
        
        $start_timestamp = timeval_twopos($pkg['start_year']) . '-';
        $start_timestamp .= timeval_twopos($pkg['start_month']) . '-';
        $start_timestamp .= timeval_twopos($pkg['start_day']) . ' ';
        $start_timestamp .= timeval_twopos($pkg['start_hour']) . ':';
        $start_timestamp .= timeval_twopos($pkg['start_minute']) . ':';
        $start_timestamp .= timeval_twopos($pkg['start_second']);
        
        if (timestamp_correct($start_timestamp)) {
            $pkg['time_start'] = "'$start_timestamp'";
        } else {
            add_error("Incorrect format of starting time!");
        }
    }
    
    
    // Check end time    
    if (isset($_POST['end_never']) && $_POST['end_never'] == 'yes') {
        $pkg['end_never'] = 1;
        $pkg['end_day'] = 0;
        $pkg['end_month'] = 0;
        $pkg['end_year'] = intval(date('Y')) + 1;
        $pkg['end_hour'] = 0;
        $pkg['end_minute'] = 0;
        $pkg['end_second'] = 0;
        $pkg['time_end'] = "NULL";
    } else {
        $pkg['end_never'] = 0;
        $pkg['end_day'] = $_POST['end_day'];
        $pkg['end_month'] = $_POST['end_month'];
        $pkg['end_year'] = $_POST['end_year'];
        $pkg['end_hour'] = $_POST['end_hour'];
        $pkg['end_minute'] = $_POST['end_minute'];
        $pkg['end_second'] = $_POST['end_second'];
        
        $end_timestamp = timeval_twopos($pkg['end_year']) . '-';
        $end_timestamp .= timeval_twopos($pkg['end_month']) . '-';
        $end_timestamp .= timeval_twopos($pkg['end_day']) . ' ';
        $end_timestamp .= timeval_twopos($pkg['end_hour']) . ':';
        $end_timestamp .= timeval_twopos($pkg['end_minute']) . ':';
        $end_timestamp .= timeval_twopos($pkg['end_second']);
        
        if (timestamp_correct($end_timestamp)) {
            $pkg['time_end'] = "'$end_timestamp'";
        } else {
            add_error("Incorrect format of ending time!");
        }
    }
    

    // Process the input file ==============================================================

    if ($pkg['input_method'] == 'file' || $pkg['input_method'] == 'hash_file') {
        // Uploading an encrypted file or file with hash
        if ($pkg['input_method'] == 'file' && !isset($_FILES['input_file']['tmp_name']) || empty($_FILES['input_file']['tmp_name'])) {
            add_error("You have to select an input file!");
        } else {
            $uploaded_file = $config['upload_dir'] . $_SERVER['REQUEST_TIME'] . '_' . basename($_FILES['input_file']['name']);
            if (!move_uploaded_file($_FILES['input_file']['tmp_name'], $uploaded_file)) {
                add_error("Possible file upload attack!");
            } else {
                if ($pkg['input_method'] == 'file') {
                    // Encrypted file was uploaded
                    if (isset($pkg['hash_type']) && $pkg['hash_type'] >= 0) {
                        // Manually set hash file
                        $c = $config['xtohashcat_bin_dir'] . '/XtoHashcat.py ' . $uploaded_file;
                        $cmd = 'cd ' . $config['xtohashcat_bin_dir'] . ' && '  . $config['xtohashcat_bin_dir'] . '/XtoHashcat.py ' . $uploaded_file;
                        $cmd .= ' -f ' . $pkg['hash_type'] . '; echo $?';
                        $xh_output = explode("\n", shell_exec($cmd));
                        $xh_return_code = $xh_output[count($xh_output) - 2];
                        if ($xh_return_code == "0") {
                            //echo "<p><b>Hash extraction successful!</b></p>"; // Just for info
                            $pkg['hash'] = $xh_output[0]; 
                        } else {
                            add_error('Unable to process the input file for a given hash type! Try autodetect.');
                        }                      
                    } else {
                        // Automatically detect hash type
                        $c = $config['xtohashcat_bin_dir'] . '/XtoHashcat.py ' . $uploaded_file;
                        $cmd = 'cd ' . $config['xtohashcat_bin_dir'] . ' && '  . $config['xtohashcat_bin_dir'] . '/XtoHashcat.py ' . $uploaded_file . '; echo $?';
                        $xh_output = explode("\n", shell_exec($cmd));
                        $xh_return_code = $xh_output[count($xh_output) - 2];
                        if ($xh_return_code == "0") {
                            if (!is_numeric($xh_output[1]) && !hash_type_exists($xh_output[1])) {
                                die("XtoHashcat reported a non-existing hash type: $hash_type");
                            }
                            //echo "<p><b>Hash extraction successful!</b></p>"; // Just for info
                            $pkg['hash'] = $xh_output[0];
                            $pkg['hash_type'] = intval($xh_output[1]);
                            
                        } else {
                            add_error('Input file format was not recognized (or is not encrypted)!');
                        }  
                    }
                } else if ($pkg['input_method'] == 'hash_file') {
                    // File with hash was uploaded
                    $pkg['hash'] = file_get_contents($uploaded_file);
                }
                $pkg['hash_entered'] = true;
            }
        }
    } else if ($pkg['input_method'] == 'hash_text') {
        // No file uploading needed
        if (isset($_POST['hash_text']) && !empty($_POST['hash_text'])) {
            $pkg['hash'] = $_POST['hash_text'];
            $pkg['hash_entered'] = true;
        } else {
            add_error("You have to enter a hash!");
        }
    }
    
    
    // Password generator settings =========================================================
    $ascii_chars = "";
    $charset_xml = "";

    if (/* $ok && */isset($pkg['attack'])) {
        $func = 'process_package_' . $pkg['attack'];
        $func($pkg, $ok);
    }

    // Generate a unique token =============================================================
    $pkg['token'] = hash('sha256', date('YmdHis') . $_SERVER['REMOTE_ADDR'] . $pkg['name']);


    // Count if hashfile conains only SINGLE HASH !!! ======================================    
    if ($pkg['hash_entered'] && $pkg['verify_hash_format']) {
        /*
        if (!empty($pkg['hash']) || strlen($pkg['hash']) == 0) {
            add_error("Hash is empty!");
        } else
        */
        
        //echo "<p><b>" . $pkg['hash'] . "</b></p>";
        /*
        if (substr_count($pkg['hash'], "\n") == 0) {
            add_error("Hash must end with a newline character!");
        } else
        */
        if (substr_count($pkg['hash'], "\n") > 1) {
            add_error("Input file can contain only ONE hash (line)!");
        } else {        
            if (!verify_hash_format($pkg['hash_type'], $pkg['hash'])) {
                add_error("Incorrect hash for format " . $pkg['hash_type'] . "!");
                
                echo "<p><b><font color=\"red\">Incorrect hash " . $pkg['hash'] . " for format " . $pkg['hash_type'] . "!</font></b></p>"; // TODO: REMOVE
            } else {
                echo "<p><b>Hash format OK!</b></p>";
            }
        }
        
    }
    
    

    // Check hashcache (if needed) =========================================================
    if ($pkg['check_hashcache']) {
        $sql = "SELECT result FROM `" . $config['mysql_prefix'] . "hashcache` WHERE hash_type = " . $pkg['hash_type'];
        $sql .= " AND hash = '" . mysqli_real_escape_string($mysqli, $pkg['hash']) . "'";
        if (!$result = $mysqli->query($sql)) {
            die("<p>Unable to read info from hashcache!</p><br/>\n");
        }
        if ($result->num_rows > 0) {
            $hashcache_info = $result->fetch_array(MYSQLI_ASSOC);
            $pkg['info_only'] = true;
            $pkg['hash_in_cache'] = true;
            $pw_base64 = $hashcache_info['result'];
            echo "<p><span class=\"special_info\"><b>Hash found in cache!</b> Password: " . htmlentities(base64_decode($pw_base64)) . "</b></span></p>";
        }
    }

    // Create a new package ================================================================
    $package_id = -1; // We will know after adding to database
    $pkg_added = false;
    if ($ok) {
        // Everything seems okay, so let's add the package to database
        
        $cfg_dict = "";
        
        if (array_key_exists($pkg['attack'], $pkg['attack_modes'])) {
            $pkg['attack_mode'] = $pkg['attack_modes'][$pkg['attack']];
        } else {
            die("Internal error: Attack mode was not specified for " . $cfg['attack'] . "!"); // For incomplete attack modes...
        }
        
        foreach($to_dictionary as $key => $type) {
            add_to_dictionary($cfg_dict, $key, $type, $pkg[$key]);
        }
        /*
        echo "<p>" . $pkg['attack'] . "</p>";
        echo "<p>" . var_dump($pkg['attack_modes']) . "</p>";
        echo "<p>" . $pkg['attack_modes'][$pkg['attack']] . "</p>";
        */
        
        
        if ($pkg['info_only']) {
            echo "<p>";
            echo "Total real keyspace: " . $pkg['keyspace'];
            echo "</p>\n";
            echo "<p>";
            echo "Total Hashcat keyspace: " . $pkg['hc_keyspace'];
            echo "</p>\n";
        }
        
        $db_data = array(
            'token' => "'" . $pkg['token'] . "'",
            'attack' => "'" . mysqli_real_escape_string($mysqli, $pkg['attack']) . "'",
            'attack_mode' => $pkg['attack_mode'],
            'hash_type' => $pkg['hash_type'],
            'hash' => "'" . mysqli_real_escape_string($mysqli, $pkg['hash']) . "'",
            'status' => '0',
            'result' => "NULL",
            'keyspace' => $pkg['keyspace'],
            'hc_keyspace' => $pkg['hc_keyspace'],
            'indexes_verified' => '0',
            'current_index' => '0',
            'time' => 'NOW()',
            'name' => "'" . mysqli_real_escape_string($mysqli, $pkg['name']) . "'",
            'comment' => "'" . mysqli_real_escape_string($mysqli, $pkg['comment']) . "'",
            'time_start' => $pkg['time_start'],
            'time_end' => $pkg['time_end'],
            'cracking_time' => '0',
            'seconds_per_job' => $pkg['seconds_per_job'],
            'config' => "'" . $cfg_dict . "'",
            'dict1' => "'" . mysqli_real_escape_string($mysqli, $pkg['dict1']) . "'",
            'dict2' => "'" . mysqli_real_escape_string($mysqli, $pkg['dict2']) . "'",
            'replicate_factor' => $pkg['replicate_factor']
        );
        
        $sql = "INSERT INTO `" . $config['mysql_prefix'] . "package` ";
        $sql .= sql_data_part($db_data);

        if (!$pkg['info_only']) {
            if (!$result = $mysqli->query($sql)) {          
              //echo mysqli_error($mysqli);
              die("<p>Unable to add package due to internal error!</p><br/>\n");
            }
            
            $pkg_added = true;
            
            // Now get the assigned package ID
            $sql = "SELECT id FROM `" . $config['mysql_prefix'] . "package` WHERE token = '" . $pkg['token'] . "'";
            if (!$result = $mysqli->query($sql)) {
              die("<p>Unable to find ID of added package! Would not proceed to postprocessing!</p><br/>\n");
            }
            $row = $result->fetch_row();
            $package_id = $row[0];
        }
    }
    
    // Call the postprocess function for the given attack
    if ($ok && $pkg_added && !$pkg['info_only']) {
        $func = 'postprocess_package_' . $pkg['attack'];
        $func($pkg, $ok, $package_id);
    }
    
    if (!$ok && $pkg_added) {
        // Postprocessing failed -> Remove the package!
        error_cleanup($pkg['token']);
        die("<p>Postprocessing failed!</p><br/>\n");
        /*
        $sql = "DELETE FROM `" . $config['mysql_prefix'] . "package` WHERE token = $token";
        if (!$result = $mysqli->query($sql)) {
          die("<p>Postprocessing failed and the system was <b>unable to remove</b> the broken package (id=$package_id)</p><br/>\n");
        }
        die("<p>Postprocessing failed!</p><br/>\n");
        */
    }
}
?>
