<?php
require_once("inc/guard.inc.php");
require_once("inc/config.inc.php"); // For $config['project_user']

function sql_data_part($data) {
    $sql = "(";
    $num = count($data);
    
    $counter = 0;
    foreach ($data as $column => $value) {
        $sql .= "$column";
        $counter++;
        if ($counter != $num) {
            $sql .= ", ";
        }
    }
    
    $sql .= ") VALUES (";
    
    $counter = 0;
    foreach ($data as $column => $value) {
        $sql .= "$value";
        $counter++;
        if ($counter != $num) {
            $sql .= ", ";
        }
    }        
    $sql .= ")";
    
    return $sql;
}

function do_as_boincuser($cmd) {
    global $config;
    //$cmd_prefix = 'sudo -u ' . $config['project_user'] . ' sh -c ';
    $cmd_prefix = 'sudo -u ' . $config['project_user'] . ' ';
    return shell_exec($cmd_prefix . $cmd);
}

function add_to_dictionary(&$dict_string, $name, $type, $value) {
    $dict_string .= "|||";
    $dict_string .= $name;
    $dict_string .= "|";
    $dict_string .= $type;
    $dict_string .= "|";
    $dict_string .= strlen($value);
    $dict_string .= "|";
    $dict_string .= $value;
    $dict_string .= "|||\n";
}

/*
function parse_dictionary($dict_string) {
    $dict = array();
    $dict_exploded = explode("\n", str_replace("|||", "", $dict_string));
    echo var_dump($dict_exploded);
        
    return $dict;
}
*/

function lines_num($str) { // Returns the number of newlines in string
    $lines_arr = preg_split('/\n|\r/',$str);
    $num_newlines = count($lines_arr); 
    return $num_newlines;
}

function lines_in_file($path) { // Returns the number of lines in a text file
    $linecount = 0;
    $handle = fopen($path, "r");
    while(!feof($handle)){
        $line = fgets($handle);
        $linecount++;
    }
    fclose($handle);
    return $linecount;
}


function ps_running($name) {
    if (lines_num(shell_exec("ps -ef | grep $name | grep -v grep")) == 1) {
        return false;
    } else {
        return true;
    }
}

function feeder_running() {
    return ps_running("feeder");
}

function transitioner_running() {
    return ps_running("transitioner");
}

function deleter_running() {
    return ps_running("file_deleter");
}

function generator_running() {
    return ps_running("work_generator");
}

function validator_running() {
    return ps_running("bitwise_validator");
}

function assimilator_running() {
    return ps_running("assimilator");
}

function myexec($command) {
    if( ($fp = popen($command, "r")) ) {
        while( !feof($fp) ){
            echo fread($fp, 1024);
            flush(); // you have to flush buffer
        }
        fclose($fp);
    }
}

function disable_ob() {
    // Turn off output buffering
    ini_set('output_buffering', 'off');
    // Turn off PHP output compression
    ini_set('zlib.output_compression', false);
    // Implicitly flush the buffer(s)
    ini_set('implicit_flush', true);
    ob_implicit_flush(true);
    // Clear, and turn off output buffering
    while (ob_get_level() > 0) {
        // Get the curent level
        $level = ob_get_level();
        // End the buffering
        ob_end_clean();
        // If the current level has not changed, abort
        if (ob_get_level() == $level) break;
    }
    // Disable apache output buffering/compression
    if (function_exists('apache_setenv')) {
        apache_setenv('no-gzip', '1');
        apache_setenv('dont-vary', '1');
    }
}

function formatSizeUnits($bytes) {
    if ($bytes >= 1073741824)
    {
        $bytes = number_format($bytes / 1073741824, 2) . ' GB';
    }
    elseif ($bytes >= 1048576)
    {
        $bytes = number_format($bytes / 1048576, 2) . ' MB';
    }
    elseif ($bytes >= 1024)
    {
        $bytes = number_format($bytes / 1024, 2) . ' kB';
    }
    elseif ($bytes > 1)
    {
        $bytes = $bytes . ' bytes';
    }
    elseif ($bytes == 1)
    {
        $bytes = $bytes . ' byte';
    }
    else
    {
        $bytes = '0 bytes';
    }

    return $bytes;
}

/*
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
*/

// Function for working with fc_settings

function settings_get($key) {
    global $config;
    global $mysqli;
     if (!preg_match_all('/^[a-z_]+$/', $key, $match, PREG_SET_ORDER, 0)) {
        die('settings_get(): invalid key format!');
    }
    
    $sql = "SELECT $key FROM `" . $config['mysql_prefix'] . "settings`";
    if (!$result = $mysqli->query($sql)) {
        die('settings_get(): key does not exist!');
    }
    $row = $result->fetch_row();
    return $row[0];
}

function hashcache_lookup($hash, $hash_type) {
    global $config;
    global $mysqli;
    $sql = "SELECT result FROM `" . $config['mysql_prefix'] . "hashcache` WHERE hash_type = $hash_type";
    $sql .= " AND hash = '" . mysqli_real_escape_string($mysqli, $hash) . "'";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read info from hashcache!</p><br/>\n");
    }
    if ($result->num_rows > 0) {
        $hashcache_info = $result->fetch_array(MYSQLI_ASSOC);
        $pkg['info_only'] = true;
        $pkg['hash_in_cache'] = true;
        $pw_base64 = $hashcache_info['result'];
        return $pw_base64;
    } else {
        return NULL;
    }
}

function get_masks_for_package($package_id) {
    global $config;
    global $mysqli;
    $masks = array();
    $sql = "SELECT * FROM `" . $config['mysql_prefix'] . "mask` WHERE package_id = $package_id";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read mask info!</p><br/>\n");
    }
    if ($result->num_rows > 0) {
        while ($mask_info = $result->fetch_array(MYSQLI_ASSOC)) {
            array_push($masks, $mask_info);
        }
    }
    return $masks;
}

function get_jobs_for_package($package_id) {
    global $config;
    global $mysqli;
    $jobs = array();
    $sql = "SELECT * FROM `" . $config['mysql_prefix'] . "job` WHERE package_id = $package_id";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read job info for given package!</p><br/>\n");
    }
    if ($result->num_rows > 0) {
        while ($job_info = $result->fetch_array(MYSQLI_ASSOC)) {
            array_push($jobs, $job_info);
        }
    }
    return $jobs;
}
/*
function get_mapped_hosts($package_id) {
    global $config;
    global $mysqli;
    
    $sql = "SELECT id, userid, domain_name, last_ip_addr, p_model, os_name, os_version FROM ";
    $sql .= "host WHERE id";
    $sql .=" IN (SELECT boinc_host_id FROM `" . $config['mysql_prefix'] . "host_activity` WHERE package_id = $pkg_id) ORDER BY id DESC";
    
    
    $jobs = array();
    $sql = "SELECT * FROM `" . $config['mysql_prefix'] . "job` WHERE package_id = $package_id";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read job info for given package!</p><br/>\n");
    }
    if ($result->num_rows > 0) {
        while ($job_info = $result->fetch_array(MYSQLI_ASSOC)) {
            array_push($jobs, $job_info);
        }
    }
    return $masks;
}
*/

function get_boinc_host_info($boinc_host_id) {
    global $config;
    global $mysqli;
    $host = array();
    $sql = "SELECT * FROM `host` WHERE id = $boinc_host_id";
    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read job info about BOINC host!</p><br/>\n");
    }
    if ($result->num_rows == 0) {
        return NULL;
    } else {
        return $result->fetch_array(MYSQLI_ASSOC);
    }
}

function get_boinc_host_name($boinc_host_id) {
    global $config;
    global $mysqli;    
    $host_name = "";
    $user_name = "";
    $sql = "SELECT id, userid, domain_name, last_ip_addr, p_model, os_name, os_version FROM ";
    $sql .= "host WHERE id = $boinc_host_id";

    if (!$result = $mysqli->query($sql)) {
        die("<p>Unable to read host information!</p><br/>\n");
    }

    if ($result->num_rows == 0) {
        //return "(unassigned)";
        return "-";
    } else {
        $host = $result->fetch_array(MYSQLI_ASSOC);
        $sql2 = "SELECT name FROM `user` WHERE id = " . $host['userid'];
        if ($result2 = $mysqli->query($sql2)) {
            if ($result2->num_rows > 0) {
                $user = $result2->fetch_row();
                $user_name = $user[0];
            }
        }
        $host_name = $boinc_host_id . " - " . htmlentities(stripcslashes($host['domain_name'])) . " (" . htmlentities(stripcslashes($user_name)) .
            ", " . $host['last_ip_addr'] . ")";
        return $host_name;
    }
}

$months = array(
    'January',
    'February',
    'March',
    'April',
    'May',
    'June',
    'July ',
    'August',
    'September',
    'October',
    'November',
    'December',
);

function timeval_twopos($timeval) {
    $val = "$timeval";
    if (strlen($val) == 1) {
        $val = "0$val";
    }
    return $val;
}

function timestamp_correct($date)
{
    $d = DateTime::createFromFormat('Y-m-d H:i:s', $date);
    return $d && $d->format('Y-m-d H:i:s') === $date;
}

?>
