<?php
require_once("inc/guard.inc.php");
require_once("inc/mysql.inc.php");
//require_once("inc/package_defaults.php"); // Load default confguration values for a new package
//require_once("inc/dict_functions.inc.php"); // Helping functions for password dictionary management
require_once("inc/package_builder.inc.php");
require_once("inc/hashcat_info.inc.php");

$pkg = array(); // All package settings
$to_dictionary = array(); // Keys of $pkg which will be included in TLV config dictionary

// Set common defaults
set_defaults($pkg, $to_dictionary);

// Include defaults for other attack types
foreach ($attack_types as &$attack) {
    $func = 'set_defaults_' . $attack;
    $func($pkg, $to_dictionary);
}


if (isset($_POST['add'])) {
    $error = "";
    $ok = TRUE;
    process_package($pkg, $ok); // $_POST is global, so does not have to be included
    
    if ($ok) {
        if ($pkg['info_only']) {
            if ($pkg['hash_in_cache']) {
                echo "<p>Package was not added because the password was already found in cache.<br/>";
                echo "If you wish to add the package anyway, add it again and uncheck &quot;Verify hash format before adding&quot; ";
                echo "or you can <a href=\"?i=hashcache\">visit/clear the cache</a>.";
                echo "</p>";
            }
        } else {
            echo "<p>Package successfully added.</p>";
        }
        goto end;
    } else {
        echo "<p><span style=\"color: red;\">$error</span></p>";
    }
}

echo "<h1>Create new package</h1>\n";

draw_form($pkg);

end:
?>
