<?php
require_once("inc/guard.inc.php");
require_once("inc/mysql.inc.php");
require_once("inc/hashcat_info.inc.php");

if (isset($_GET['pkg']) && ctype_digit($_GET['pkg'])) {
    $pkg_num = intval($_GET['pkg']);
    $new_status = 0;
    $operation_requested = 0;
    $extra = '';
    $attack = NULL;
    
    if ($_GET['action'] == 'start') {
        echo "<p>Starting package number $pkg_num...</p>";
        $new_status = 10;
        $operation_requested = 1;
    } else if ($_GET['action'] == 'suspend') {
        echo "<p>Suspending package number $pkg_num...</p>";
        $new_status = 0;
        $operation_requested = 1;
    } else if ($_GET['action'] == 'restart') {
        echo "<p>Restarting package number $pkg_num...</p>";
        $new_status = 10;
        $operation_requested = 1;
        $extra = ', result = NULL, indexes_verified = 0, current_index = 0, cracking_time = 0, time_end = NULL';
        
        $sql = "SELECT attack FROM `" . $config['mysql_prefix'] . "package`";
        $sql .= "WHERE id = $pkg_num";
   
        if ($result = $mysqli->query($sql)) {
            $package = $result->fetch_array(MYSQLI_ASSOC);
            $attack = $package['attack'];
        } else {
            die("<p>Unable to get the attack type of the selected package!</p><br/>\n");
        }

    }
    // TODO: Add support for restart, stop, etc. !!!
    
    if ($operation_requested) {
        $sql = "UPDATE `" . $config['mysql_prefix'] . "package` ";
        $sql .= "SET status = $new_status $extra ";
        $sql .= "WHERE id = $pkg_num";
        
        if ($result = $mysqli->query($sql)) {
            echo "<p>Operation successfull.</p>";
        } else {
            die("<p>Unable to perform the selected action on a database!</p><br/>\n");
        }
 
        
        // Brute & Markov? => Need to reset current_index for each mask
        if ($attack == 'brute' || $attack == 'markov') {
            $sql = "UPDATE `" . $config['mysql_prefix'] . "mask` ";
            $sql .= "SET current_index = 0 ";
            $sql .= "WHERE package_id = $pkg_num";
            
            if ($result = $mysqli->query($sql)) {
            } else {
                die("<p>Failed to reset current indexes for each mask!</p><br/>\n");
            }
        }
    }
}

echo "<h1>Packages</h1>\n";

echo '<form action="index.php?i=new_package" method="POST">' . "\n";
echo '<button type="submit"> Create new package </button>&nbsp;';
echo '</form><br/>' . "\n";

echo "Filter: &nbsp; ";
echo "<a href=\"?i=packages&display=all\">all</a> &nbsp; \n";
echo "<a href=\"?i=packages&display=running\">running</a> &nbsp; \n";
echo "<a href=\"?i=packages&display=ready\">ready</a> &nbsp; \n";
echo "<a href=\"?i=packages&display=finished\">finished</a> &nbsp; \n";
echo "<a href=\"?i=packages&display=exhausted\">exhausted</a> &nbsp; \n";
echo "<a href=\"?i=packages&display=malformed\">malformed</a> &nbsp; \n";

echo "<br/>\n<hr/>\n";

$filter = "1";
if (isset($_GET['display'])) {
    $display = $_GET['display'];
    switch($display) {
        default:
        case "all":
            $filter = "1";
            echo "<h2>All packages</h2>\n";
        break;
        case "running":
            $filter = "status >= " . PACKAGE_RUNNING;
            echo "<h2>All running packages</h2>\n";
        break;
        case "ready":
            $filter = "status = 0";
            echo "<h2>All ready packages</h2>\n";
        break;
        case "finished":
            $filter = "status = 1";
            echo "<h2>All finished packages</h2>\n";
        break;
        case "exhausted":
            $filter = "status = 2";
            echo "<h2>All exhausted packages</h2>\n";
        break;
        case "malformed":
            $filter = "status = 3";
            echo "<h2>All malformed packages</h2>\n";
        break;
    }
}

$sql = "SELECT id, status, name, attack, hash_type, indexes_verified, hc_keyspace, result FROM  `" . $config['mysql_prefix'] . "package` WHERE $filter ORDER BY id DESC";
if (!$result = $mysqli->query($sql)) {
    die("<p>Unable to read package information!</p><br/>\n");
}

// Obtain mapping: hash_type(ID) => hash type name
$typemap = get_hashtypes_idtoname();

if ($result->num_rows > 0) {
    echo "<table id=\"package_table\">\n";
    echo "<tr class=\"heading\">\n";
    echo "<td>ID</td>\n";
    echo "<td>status</td>\n";
    echo "<td>operation</td>\n";
    echo "<td>name</td>\n";
    echo "<td>attack</td>\n";
    echo "<td>hash type</td>\n";
    echo "<td>progress</td>\n";
    echo "<td>password</td>\n";
    echo "</tr>\n";
    while ($package = $result->fetch_array(MYSQLI_ASSOC)) {
        
        $id = $package['id'];
        $status = $package['status'];
        
        echo "<tr>\n";
        echo "<td>\n";
        echo "<a href=\"?i=package_info&id=$id\">";
        echo $id;
        echo "</a>";
        echo "</td>\n";
        echo "<td>\n";
        /*
        if (intval($package['hc_keyspace']) == 0) {
            $progress = "??";
        } else {
            $progress = round((intval($package['indexes_verified']) / intval($package['hc_keyspace'])) * 100, 2); // TOOD - fix for 
        }
        */
        $progress = 0;
        if (intval($package['hc_keyspace']) > 0) {
            $progress = round((intval($package['indexes_verified']) / intval($package['hc_keyspace'])) * 100, 2); // TOOD - fix for 
        }
        if ($status == 0) {
            echo "<b><span style=\"color: #997300;\">ready</span></b>";
        } else if ($status == 1) {
            $progress = 100;
            echo "<b><span style=\"color: #006600;\">finished</span></b>";
        } else if ($status == 2) {
            $progress = 100;
            echo "<b><span style=\"color: #FF0000;\">exhausted</span></b>";
        } else if ($status == 3) {
            echo "<b><span style=\"color: #000000;\">malformed</span></b>";
        } else if ($status == 4) {
            echo "<b><span style=\"color: #808080;\">timeout</span></b>";
        } else if ($status == 12) {
            echo "<b><span style=\"color: #00b300;\">finishing</span></b>";
        } else if ($status >= 10) {
            echo "<b><span style=\"color: #000099;\">running</span></b>";
        }
        
        
        
        echo "</td>\n";
        echo "<td>\n";
        echo "<a href=\"?i=jobs&pkg=$id\">jobs</a> &nbsp ";
        if ($status == 0) {
            echo "<a href=\"javascript:operation('?i=packages&pkg=" . $id . "&action=start', 'START')\">start</a>";
        } else if ($status == 1 || $status == 2) {
            echo "<a href=\"javascript:operation('?i=packages&pkg=" . $id . "&action=restart', 'RESTART')\">restart</a>";
        } else if ($status >= 10) {
            echo "<a href=\"javascript:operation('?i=packages&pkg=" . $id . "&action=suspend', 'SUSPEND')\">suspend</a>";
        }
        echo " &nbsp <a href=\"?i=host_mapping&pkg_id=$id\">hosts</a>";
        echo "</td>\n";
        echo "<td>\n";
        //echo "<a href=\"#\" style=\"td_click\">";
        echo $package['name'];
        //echo "</a>";
        echo "</td>\n";
        
        echo "<td>\n";
        echo $package['attack'];
        echo "</td>\n";
        
        echo "<td>\n";
        echo $typemap[$package['hash_type']];
        echo "</td>\n";
        
        //echo "<td>\n";
        //echo $package['charset'];
        //echo "</td>\n";
        echo "<td align=\"right\">\n";
        if ($progress != "??") {
            echo number_format($progress, 2) . " %\n";
        } else {
            echo "$progress %\n\n";
        }
        echo "</td>\n";
        echo "<td align=\"left\">\n";
        if (empty($package['result'])) {
            echo "-";
        } else {
            echo htmlentities(base64_decode($package['result']));
        }
        echo "</td>\n";
        echo "</tr>\n";
    }
    echo "</table>\n";
} else {
    echo "<p>No packages found</p>\n";
}

?>
<script type="text/javascript">
function operation(getparams, action) {
    if (confirm('Are you sure you want to '+action+' the package?')) {
        // Perform the action!
        var url = window.location.href.split('?')[0];
        url += getparams;
        window.location.replace(url);
    } else {
        // Do nothing!
    }
}
</script>

