<?php
require_once("inc/guard.inc.php");
require_once("inc/hwstats.inc.php");

function yesno($b) {
    if ($b) {
        return "<b><span style=\"color: #006600;\">YES</span></b>";
    }
    else {
        return "<b><span style=\"color: red;\">NO</span></b>";
    }
}

echo "<h1>Server info</h1>\n";

// Project info
echo "<h2>Project info</h2>\n";
echo "Name: <b>" . $config['project_name'] . "</b><br/>\n";
echo "User: <b>" . $config['project_user'] . "</b><br/>\n";

// Subystems running
echo "<h2>Subsystems running</h2>";
echo "<table>\n";

echo "<tr>\n";
echo "    <td align=\"right\">Feeder:</td>\n";
echo "    <td>" . yesno(feeder_running()) . "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "    <td align=\"right\">Transitioner:</td>\n";
echo "    <td>" . yesno(transitioner_running()) . "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "    <td align=\"right\">File deleter:</td>\n";
echo "    <td>" . yesno(deleter_running()) . "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "    <td align=\"right\">Work generator:</td>\n";
echo "    <td>" . yesno(generator_running()) . "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "    <td align=\"right\">Validator:</td>\n";
echo "    <td>" . yesno(validator_running()) . "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "    <td align=\"right\">Assimilator:</td>\n";
echo "    <td>" . yesno(assimilator_running()) . "</td>\n";
echo "</tr>\n";

echo "</table>\n";

// Server stats
echo "<h2>Server stats</h2>\n";
echo "CPU: ";
echo "<font size=\"gray\">";
echo get_cpu_type();
echo "</font>";
echo "<br/>\n";
echo "CPU usage: ";
echo number_format((float)get_server_cpu_usage(), 2, '.', '') . " %";
echo "<br/>\n";
echo "RAM usage: ";
echo number_format((float)get_server_memory_usage(), 2, '.', '') . " %";
echo "<br/>\n";
echo "Total RAM: ";
echo get_total_ram();
echo " GiB";
echo "<br/>\n";
echo "Uptime: ";
echo get_server_uptime();
echo "<br/>\n";
echo "Disk free space: ";
echo get_disk_free_space();
echo "<br/>\n";
echo "Disk total space: ";
echo get_disk_total_space();
echo "<br/>\n";

// Network stats
echo "<h2>Network connection</h2>\n";
echo "IP address: " . $_SERVER['SERVER_ADDR'];




/////////////////

echo "</div>\n";
?>
