<?php
require_once("inc/guard.inc.php");
require_once("inc/mysql.inc.php");

echo "<h1>Hash calculator</h1>\n";

$error = "";

function add_error($err) {
    global $error, $ok;
    $error .= "<p><font color=\"red\">$err</font></p>\n";
    $ok = FALSE;
}

$algos = hash_algos();
$algorithm = $algos[0];
$auth = FALSE;
$key = "";
$plaintext = "";
$hash = "";

if (isset($_POST['calculate'])) {
    $ok = TRUE;


    if (!isset($_POST['plaintext'])) {
        $plaintext = "";
    } else {
        $plaintext = $_POST['plaintext'];
    }
    
    $algorithm = $_POST['algorithm'];
    if (!isset($_POST['algorithm']) || empty($_POST['algorithm'])) {
        add_error("You have to select a hash algorithm!");
    } else if (array_search($algorithm, $algos) === FALSE) {
        add_error("Selected algorithm is not supported! Switching to $algorithm.");
    }
    
    if (isset($_POST['key'])) {
        $key = $_POST['key'];
    } else {
        $key = "";
    }
    
    if (isset($_POST['auth']) && $_POST['auth'] == 'yes') {
        $auth = TRUE;
    }
    
    if ($auth) {
        $hash = hash_hmac($algorithm, $plaintext, $key);
    } else {
        $hash = hash($algorithm, $plaintext);
    }

    if (!$ok) {
        echo $error;
    }
}



echo "<form id=\"package_form\" action=\"index.php?i=tools/hash_calculator\" method=\"POST\" enctype=\"multipart/form-data\">\n";
echo "<input type=\"hidden\" name=\"add\" value=\"yes\" />\n";
echo "<table id=\"input_form\">\n";

// GENERAL SETTINGS ==================================================================
echo "<tr>\n";
echo "<td class=\"bg_a\">\n";
echo "<h2>Input</h2>\n";
echo "<table class=\"inner_form\">\n";

// Name
echo "<tr>\n";
echo "<td align=\"right\" width=\"120px\">Algorithm:</td>\n";
echo "<td>\n";
echo "<select name=\"algorithm\">";
foreach ($algos as $algo) {
    $algo_selected = "";
    if (isset($_POST['algorithm']) && $_POST['algorithm'] == $algo) {
        $algo_selected = " selected";
    }
    echo "<option value=\"$algo\"$algo_selected>$algo</option>";
}
echo "</select>&nbsp;&nbsp;&nbsp;";

$auth_checked = "";
if ($auth) {
    $auth_checked = " checked";
}
echo "<input type=\"checkbox\" onchange=\"handle_auth(this);\" name=\"auth\" value=\"yes\"$auth_checked/> Authenticated (HMAC)";
echo "</td>\n";
echo "</tr>\n";

$keyrow_style="display:none";
if ($auth) {
    $keyrow_style="display:table-row";
}

echo "<tr id=\"keyrow\" style=\"$keyrow_style\">\n";
echo "<td align=\"right\">Key:</td>";
echo "<td>";
echo "<input type=\"text\" name=\"key\" value=\"" . htmlentities($key) . "\" />";
echo "</td>";
echo "</tr>\n";

echo "<tr>\n";
echo "<td align=\"right\">Input plaintext:</td>\n";
echo "<td>\n";
echo "<textarea name=\"plaintext\" rows=\"5\" cols=\"80\">" . htmlentities($plaintext) . "</textarea>";
echo "</td>\n";
echo "</tr>\n";

echo "</table>\n";
echo "</td>\n";
echo "</tr>\n";
echo "<tr>\n";
echo "<td class=\"bg_a\">\n";

// INPUT SETTINGS ==================================================================
echo "<h2>Output</h2>\n";
echo "<table class=\"inner_form\">\n";

// Hash type
echo "<tr>\n";
echo "<td align=\"right\" width=\"120px\">Hash:</td>\n";
echo "<td>\n";
echo "<textarea name=\"hash\" rows=\"5\" cols=\"80\">" . htmlentities($hash) . "</textarea>";
echo "</td>\n";
echo "</tr>\n";

echo "</table>\n";

echo "</td>\n";
echo "</tr>\n";
echo "<tr>\n";
echo "<td class=\"bg_a\" align=\"center\">\n";
echo "<input type=\"submit\" name=\"calculate\" value=\" Calculate \">";
echo "</tr>\n";

echo "</table>\n";

echo "</td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "</td>\n";
echo "</tr>\n";
?>
<script type="text/javascript">

function handle_auth(cb) {  
    if (cb.checked) {
        document.getElementById("keyrow").style.display='table-row';
    } else {
        document.getElementById("keyrow").style.display='none';
    }
}
</script>
